// WavePlayer.h : header file
#ifndef WAVEPLAYER_H
#define WAVEPLAYER_H

#include "Wave.h"

namespace DDJCColumnWave	{

class WavePlayer : public Wave
{
	HWAVEOUT wavedevice;
	bool playing;
	bool paused;
	bool stopping;
	static void CALLBACK waveOutProc(HWAVEOUT hwo,UINT uMsg,         
					DWORD dwInstance,DWORD dwParam1,DWORD dwParam2);
	void FillBufferAndPlay(PWAVEHDR hdr);
	virtual int FillBuffer(char* buf, int len) = 0;
	virtual int DSP(char* buf, int len)
		{ return len; }
	void Shutdown();
public:
	WavePlayer(int b, int rate, int nc);
	~WavePlayer();
	void Play();
	void Pause()
		{ paused = true; }
	void Resume();
	void Stop();
	bool Playing()
		{ return playing; }
	bool Paused()
		{ return paused; }
};

} // namespace DDJCColumnWave

#endif // WAVEPLAYER_H
