// WaveRecorder.cpp
#include "stdafx.h"
#include <stdexcept>
#include "WaveRecorder.h"

namespace DDJCColumnWave	{

WaveRecorder::WaveRecorder(int b, int rate, int nc) : Wave(b, rate, nc, 1024)
{
	wavedevice = 0;
	stopping = false;
	if (waveInOpen(&wavedevice, WAVE_MAPPER, &wfmt, 
			(DWORD)waveInProc, (DWORD)this, CALLBACK_FUNCTION) == 0)
		if (waveInPrepareHeader(wavedevice, &hdr1, sizeof(WAVEHDR)) == 0)
			if (waveInPrepareHeader(wavedevice, &hdr2, sizeof(WAVEHDR)) == 0)
				return;
	ShutDown();
	throw runtime_error("Error initializing recorder device");
}
WaveRecorder::~WaveRecorder()
{
	ShutDown();
}
void WaveRecorder::ShutDown()
{
	stopping = true;
	waveInStop(wavedevice);
	waveInReset(wavedevice);
	waveInUnprepareHeader(wavedevice, &hdr1, sizeof(WAVEHDR));
	waveInUnprepareHeader(wavedevice, &hdr2, sizeof(WAVEHDR));
	waveInClose(wavedevice);
}
void WaveRecorder::Record()
{
	waveInAddBuffer(wavedevice, &hdr1, sizeof(WAVEHDR));
	waveInAddBuffer(wavedevice, &hdr2, sizeof(WAVEHDR));
	waveInStart(wavedevice);
}
void WaveRecorder::SaveBuffer(PWAVEHDR hdr)
{
	if (!stopping)	{
		StoreData(hdr->lpData, hdr->dwBytesRecorded);
		waveInAddBuffer(wavedevice, hdr, sizeof(WAVEHDR));
	}
}
void CALLBACK WaveRecorder::waveInProc(HWAVEOUT hwo,UINT uMsg,DWORD 
									  dwInstance,DWORD dwParam1,DWORD dwParam2)
{
	WaveRecorder* wp = reinterpret_cast<WaveRecorder*>(dwInstance);
	PWAVEHDR hdr = reinterpret_cast<PWAVEHDR>(dwParam1);
	switch (uMsg)	{
		case WIM_DATA:
			wp->SaveBuffer(hdr);
			break;
		default:
			break;
	}
}

} // namespace DDJCColumnWave
