package example.MDBean;

import javax.ejb.CreateException;
import javax.ejb.MessageDrivenBean;
import javax.ejb.MessageDrivenContext;

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;

/**
 * @author Surlu M. Rao
 */
public class MessagePipeBean implements MessageDrivenBean, MessageListener {

  private MessageDrivenContext m_context;
  
  /**
   * This method is required by the EJB Specification
   *
   */
  public void ejbActivate() {
  }

  /**
   * This method is required by the EJB Specification,
    */
  public void ejbRemove() {
    m_context = null;
  }

  /**
   * This method is required by the EJB Specification,
   */
  public void ejbPassivate() {
  }

  /**
   * Sets the session context.
   *
   * @param ctx               MessageDrivenContext Context for session
   */
  public void setMessageDrivenContext(MessageDrivenContext ctx) {
    m_context = ctx;
  }

  /**
   * ejbCreate() with no arguments is required by the EJB 2.0 specification
   */
  public void ejbCreate () throws CreateException {
  }

  /**
   * MessageListener implementation
   * This method just takes the message and pipes to the system output.
   * 
   * @exception  completely handles all exceptions
   */
  public void onMessage(Message msg) {
    TextMessage tm = (TextMessage) msg;
    try {
      String text = tm.getText();
      System.out.println("MessagePipeBean piped : " + text);
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }
}


