// EditorView.cpp : implementation file
//

#include "stdafx.h"
#include "listener.h"
#include "EditorView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditorView

IMPLEMENT_DYNCREATE(CEditorView, CRichEditView)

CEditorView::CEditorView()
{
}

CEditorView::~CEditorView()
{
}


BEGIN_MESSAGE_MAP(CEditorView, CRichEditView)
	//{{AFX_MSG_MAP(CEditorView)
	ON_WM_CHAR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditorView drawing

void CEditorView::OnInitialUpdate()
{
	CRichEditView::OnInitialUpdate();
}

void CEditorView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CEditorView diagnostics

#ifdef _DEBUG
void CEditorView::AssertValid() const
{
	CRichEditView::AssertValid();
}

void CEditorView::Dump(CDumpContext& dc) const
{
	CRichEditView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEditorView message handlers

BOOL CEditorView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	if (!CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext))
        return FALSE;
    this->SetFont(CFont::FromHandle((HFONT)GetStockObject(ANSI_FIXED_FONT)));
    return TRUE;
}

typedef struct CallbackData CallbackData;
struct CallbackData {
    char *buf;
    int len;
};

static DWORD CALLBACK EditStreamCallback(DWORD dwCookie,LPBYTE pbBuff,LONG cb,LONG *pcb)
{
    CallbackData *data = (CallbackData *)dwCookie;
    if (!(data->buf = (char *)realloc(data->buf,data->len + cb + 1)))
        return -1;
    strncpy(&data->buf[data->len],(char *)pbBuff,cb);
    data->len += cb;
    *pcb = cb;
    return 0;
}

void CEditorView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
    /* handle control-enter */
    if (nChar == '\n') {
        extern CListenerApp theApp;
        CRichEditCtrl &editCtrl = GetRichEditCtrl();
        BobInterpreter *i = theApp.m_interpreter;
        CallbackData data;
        EDITSTREAM stream;

        /* setup the callback function */
        stream.dwCookie = (DWORD)&data;
        stream.dwError = 0;
        stream.pfnCallback = EditStreamCallback;
        data.buf = NULL;
        data.len = 0;

        /* get the edit control text */
        if (editCtrl.StreamOut(SF_TEXT,stream) > 0 && data.buf) {

            /* terminate the buffer */
            data.buf[data.len] = '\0';

            /* copy the text to the transcript pane */
            BobStreamPutS(data.buf,i->standardOutput);
            if (data.buf[data.len - 1] != '\n')
                BobStreamPutC('\n',i->standardOutput);

            /* evaluate the buffer contents */
            if (EvalString(i,data.buf,data.len)) {

                /* clear the edit buffer if evaluation was successful */
                editCtrl.SetSel(0,-1);
                editCtrl.Clear();
            }

            /* free the buffer */
            free(data.buf);
        }
    }

    /* handle other characters */
    else
	    CRichEditView::OnChar(nChar, nRepCnt, nFlags);
}
