// TranscriptView.cpp : implementation file
//

#include "stdafx.h"
#include "listener.h"
#include "TranscriptView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTranscriptView

IMPLEMENT_DYNCREATE(CTranscriptView, CRichEditView)

CTranscriptView::CTranscriptView()
{
    m_outPtr = m_outBuf;
}

CTranscriptView::~CTranscriptView()
{
}


BEGIN_MESSAGE_MAP(CTranscriptView, CRichEditView)
	//{{AFX_MSG_MAP(CTranscriptView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

int CTranscriptView::PutC(int ch)
{
    /* check for the end of a line */
    if (ch == '\n')
        PutC('\r');
    
    /* buffer the character */
    if (m_outPtr >= &m_outBuf[OUTBUFSIZE])
        FlushOutput();
    *m_outPtr++ = ch;

	/* flush output at the end of a line */
	if (ch == '\n')
		FlushOutput();

    /* return the character */
	return ch;
}

void CTranscriptView::FlushOutput(void)
{
    if (m_outPtr != m_outBuf) {
        CRichEditCtrl &editCtrl = GetRichEditCtrl();
        long start,end;

        /* terminate the output buffer */
        *m_outPtr = '\0';

        /* insert the character at the end */
        editCtrl.SetSel(0,-1);
        editCtrl.GetSel(start,end);
        editCtrl.SetSel(end,end);

        /* output to listener window */
        GuaranteeSpace();
        editCtrl.ReplaceSel(m_outBuf);

        /* clear the output buffer */
        m_outPtr = m_outBuf;
    }
}

void CTranscriptView::GuaranteeSpace(void)
{
    CRichEditCtrl &editCtrl = GetRichEditCtrl();
    int lineCount = editCtrl.GetLineCount();
    int charCount = editCtrl.LineIndex(lineCount - 1);
    if (charCount > 20000) {
        long saveStart,saveEnd;
        int lineToDelete = editCtrl.LineFromChar(2000);
        int endDelete = editCtrl.LineIndex(lineToDelete);
        editCtrl.GetSel(saveStart,saveEnd);
        editCtrl.SetSel(0,endDelete);
        editCtrl.Clear();
        saveStart -= endDelete;
        saveEnd -= endDelete;
        if (saveStart < 0) {
            saveStart = 0;
            saveEnd = -1;
        }
        editCtrl.SetSel(saveStart,saveEnd);
    }
}

/////////////////////////////////////////////////////////////////////////////
// CTranscriptView drawing

void CTranscriptView::OnInitialUpdate()
{
	CRichEditView::OnInitialUpdate();
}

void CTranscriptView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CTranscriptView diagnostics

#ifdef _DEBUG
void CTranscriptView::AssertValid() const
{
	CRichEditView::AssertValid();
}

void CTranscriptView::Dump(CDumpContext& dc) const
{
	CRichEditView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTranscriptView message handlers

BOOL CTranscriptView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	if (!CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext))
        return FALSE;
    this->SetFont(CFont::FromHandle((HFONT)GetStockObject(ANSI_FIXED_FONT)));
    return TRUE;
}
